import os
import sys
import subprocess
from gettext import gettext as _

class CoreSingleton:
    __single = None
    def __init__( self ):
        if CoreSingleton.__single:
            raise CoreSingleton.__single
        CoreSingleton.__single = self

        # Launchpad Login
        self.legacy_lplogin_file = os.path.expanduser("~/.5-a-day")
        self.lplogin = None
        if os.path.exists(self.legacy_lplogin_file):
            self.lplogin = open(self.legacy_lplogin_file).read().strip().lower()
        else:
            p = subprocess.Popen(["bzr", "launchpad-login", "--no-check"], 
                                 stdout=subprocess.PIPE)
            lplogin = p.stdout.read().strip()
            p.communicate()
            if not p.returncode:
                # return code == 0
                self.lplogin = lplogin
            else:
                print >> sys.stderr, _("""Please type in:
    bzr launchpad-login <Your Launchpad ID>""")

        self.signature_file = os.path.expanduser("~/.signature")
        self.old_signature_file = os.path.expanduser("~/.signature.old")

def Core(x = CoreSingleton):
    try:
        single = CoreSingleton()
    except CoreSingleton, s:
        single = s
    return single 
